use libloading::{Library, Symbol};
use shared::{Input, Output};

type ProcessFn = unsafe extern "C" fn(input: Input) -> Output;

fn main() {
    unsafe {
        let lib = Library::new("target/debug/libplugin.so").expect("Failed to load plugin");

        let process: Symbol<ProcessFn> = lib.get(b"process").expect("Failed to load symbol");

        let input = Input { a: 3, b: 4 };

        let output: Output = process(input);

        println!("Sum: {}", output.sum);
        println!("Product: {}", output.product);
    }
}
